org.cpsolver.ifs.extension

## Class ViolatedInitials<V extends Variable<V,T>,T extends Value<V,T>>

- java.lang.Object
- - org.cpsolver.ifs.extension.Extension<V,T>
  - - org.cpsolver.ifs.extension.ViolatedInitials<V,T>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Implemented Interfaces:
    ModelListener<V,T>

      public class ViolatedInitials<V extends Variable<V,T>,T extends Value<V,T>>
      extends Extension<V,T>

  Computation of violated initial values (minimal perturbation problem).
  It is using `Constraint.isConsistent(Value, Value)` to find out what initial values (of different variables) cannot be assigned when an arbitrary value is assigned to a variable. This information is computed in advance, before the solver is executed. It is used for better estimation of perturbation penalty (see `PerturbationsCounter`) when a value is to be assigned to a variable.
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ViolatedInitials(Solver<V,T> solver, DataProperties properties)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Set<T>` | `getViolatedInitials(T value)` Initial values that cannot be assigned when the given value is assigned
    `boolean` | `init(Assignment<V,T> assignment)` Compute the violations between any value and all other initial values

    - ### Methods inherited from class org.cpsolver.ifs.extension.Extension

      `afterAssigned, afterUnassigned, beforeAssigned, beforeUnassigned, constraintAdded, constraintRemoved, getModel, getProperties, getSolver, init, isRegistered, register, unregister, variableAdded, variableRemoved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ViolatedInitials

          public ViolatedInitials(Solver<V,T> solver,
                                  DataProperties properties)

  - ### Method Detail

    - #### init

          public boolean init(Assignment<V,T> assignment)

      Compute the violations between any value and all other initial values
      Parameters:
        `assignment` - current assignment
      Returns:
        true if initialized properly

    - #### getViolatedInitials

          public Set<T> getViolatedInitials(T value)

      Initial values that cannot be assigned when the given value is assigned
      Parameters:
        `value` - given value
      Returns:
        list of initial values that cannot be assigned due to the given value